/*
 * PLEASE NOTE: THIS DRIVER IS INCOMPLETE, LINUX-2.3.99 ONLY, AND
 *              GENERALLY A HORRIBLE HACK. THE EVENT MODEL IS WRONG,
 *              CAUSING STAIRCASE EFFECTS. THE RANGE OF THE MOUSE
 *              DISTANCE VALUATOR IS WRONG. TONS OF OTHER STUFF ARE
 *              MOST PROBABLY WRONG.
 *              I WROTE THIS WITHOUT PROPER KNOWLEDGE OF XINPUT DRIVER
 *              PROGRAMMING AND WITHOUT ENOUGH TIME, AND IT SHOWS.
 *              WAIT FOR AN ACTUAL DRIVER FROM FREDERIC IF YOU NEED SOMETHING
 *              THAT WORKS.
 */

/*
 * Copyright 1995-1999 by Frederic Lepied, France. <Lepied@XFree86.org>
 * Hacked to drive USB Graphires on Linux-USB event devices
 * by Daniel Schmitt, Germany. <pnambic@unu.nu>
 *
 * The authors of this code for the purposes of the following legal notices
 * are Frederic Lepied and Daniel Schmitt
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is  hereby granted without fee, provided that
 * the  above copyright   notice appear  in   all  copies and  that both  that
 * copyright  notice   and   this  permission   notice  appear  in  supporting
 * documentation, and  that  the  names  of   the   authors  not  be  used  in
 * advertising or publicity pertaining to distribution of the software without
 * specific,  written      prior  permission.     The     authors    make   no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE  AUTHORS  DISCLAIM  ALL  WARRANTIES   WITH   REGARD  TO  THIS SOFTWARE,
 * INCLUDING ALL IMPLIED   WARRANTIES OF MERCHANTABILITY  AND   FITNESS, IN NO
 * EVENT  SHALL  THE   AUTHORS   BE   LIABLE   FOR ANY  SPECIAL, INDIRECT   OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA  OR PROFITS, WHETHER  IN  AN ACTION OF  CONTRACT,  NEGLIGENCE OR OTHER
 * TORTIOUS  ACTION, ARISING    OUT OF OR   IN  CONNECTION  WITH THE USE    OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 */

static const char identification[] = "$Identification: 18 $";

#include <xf86Version.h>

/* The event device header (linux/input.h) needs these typedefs. */
/* Don't ask... I don't know either. I just know it works. */
typedef unsigned int __u32;
typedef unsigned short __u16;
#include <linux/input.h>

#if XF86_VERSION_CURRENT >= XF86_VERSION_NUMERIC(3,9,0,0,0)
#define XFREE86_V4 1
#endif

#ifdef XFREE86_V4
/* post 3.9 headers */

#ifndef XFree86LOADER
#include <unistd.h>
#include <errno.h>
#endif

#include <misc.h>

/* linux/input.h define BUS_ISA and BUS_PCI too */
/* this cause an error within the enum type in xf86str.h */
#undef BUS_ISA
#undef BUS_PCI

#include <xf86.h>
#define NEED_XF86_TYPES
#if !defined(DGUX)
#include <xf86_ansic.h>
#include <xisb.h>
#endif
#include <xf86_OSproc.h>
#include <xf86Xinput.h>
#include <exevents.h>		/* Needed for InitValuator/Proximity stuff */
#include <keysym.h>
#include <mipointer.h>

#ifdef XFree86LOADER
#include <xf86Module.h>
#endif

#undef memset
#define memset xf86memset
#undef sleep
#define sleep(t) xf86WaitForInput(-1, 1000 * (t))
#define wait_for_fd(fd) xf86WaitForInput((fd), 1000)
#define tcflush(fd, n) xf86FlushInput((fd))
#undef read
#define read(a,b,c) xf86ReadSerial((a),(b),(c))
#undef write
#define write(a,b,c) xf86WriteSerial((a),(char*)(b),(c))
#undef close
#define close(a) xf86CloseSerial((a))
#define XCONFIG_PROBED "(==)"
#define XCONFIG_GIVEN "(**)"
#define xf86Verbose 1
#undef PRIVATE
#define PRIVATE(x) XI_PRIVATE(x)

/*
 * Be sure to set vmin appropriately for your device's protocol. You want to
 * read a full packet before returning
 */
/*
 * for the USB event device driver, we don't actually care about these.
 */
static const char *default_options[] =
{
	"BaudRate", "9600",
	"StopBits", "1",
	"DataBits", "8",
	"Parity", "None",
	"Vmin", "1",
	"Vtime", "10",
	"FlowControl", "Xoff",
	NULL
};

static InputDriverPtr graphireusbDrv;

#else /* pre 3.9 headers */

#include "Xos.h"
#include <signal.h>
#include <stdio.h>

#define NEED_EVENTS
#include "X.h"
#include "Xproto.h"
#include "misc.h"
#include "inputstr.h"
#include "scrnintstr.h"
#include "XI.h"
#include "XIproto.h"
#include "keysym.h"

#if defined(sun) && !defined(i386)
#define POSIX_TTY
#include <errno.h>
#include <termio.h>
#include <fcntl.h>
#include <ctype.h>
#include <stdio.h>

#include "extio.h"
#else
#include "compiler.h"

#include "xf86.h"
#include "xf86Procs.h"
#include "xf86_OSlib.h"
#include "xf86_Config.h"
#include "xf86Xinput.h"
#include "xf86Version.h"
#endif

#if !defined(sun) || defined(i386)
#include "osdep.h"
#include "exevents.h"

#include "extnsionst.h"
#include "extinit.h"
#endif

#endif /* Pre 3.9 headers */

#if defined(__QNX__) || defined(__QNXNTO__)
#define POSIX_TTY
#endif

/******************************************************************************
 * debugging macro
 *****************************************************************************/
#ifdef DBG
#undef DBG
#endif
#ifdef DEBUG
#undef DEBUG
#endif

static int      debug_level = 0;
#define DEBUG 1
#if DEBUG
#define DBG(lvl, f) {if ((lvl) <= debug_level) f;}
#else
#define DBG(lvl, f)
#endif

#define ABS(x) ((x) > 0 ? (x) : -(x))

/******************************************************************************
 * GraphireUSBDeviceRec flags
 *****************************************************************************/
#define DEVICE_ID(flags) ((flags) & 0x07)

#define STYLUS_ID		1
#define MOUSE_ID		2
#define ERASER_ID		4
#define ABSOLUTE_FLAG		8
#define FIRST_TOUCH_FLAG	16
#define	KEEP_SHAPE_FLAG		32

typedef struct _GraphireUSBDeviceState
{
    int			device_id;
    int			device_type;
    int			x;
    int			y;
    int			buttons;
    int			pressure;
    int			wheel;
    int			proximity;
} GraphireUSBDeviceState;

#define MAX_SUPPRESS      200

/* Circular queue structure */
struct cqueue
{
	int *queue;
	int qsize;
	int qmax;
	int tail;
};

typedef struct _GraphireUSBSmoothRec
{
	struct cqueue cq;
	int average;
} GraphireUSBSmoothRec;

typedef struct _GraphireUSBDeviceRec
{
    /* configuration fields */
    unsigned char	flags;		/* various flags (device type, absolute, first touch...) */
    int			topX;		/* X top */
    int			topY;		/* Y top */
    int			bottomX;	/* X bottom */
    int			bottomY;	/* Y bottom */
    double		factorX;	/* X factor */
    double		factorY;	/* Y factor */
    int			initNumber;     /* magic number for the init phasis */

    struct _GraphireUSBCommonRec *common;	/* common info pointer */

    /* state fields */
    int			oldX;		/* previous X position */
    int			oldY;		/* previous Y position */
    int			oldZ;		/* previous pressure */
    int			oldWheel;	/* previous wheel value */
    int			oldButtons;	/* previous buttons state */
    int			oldProximity;	/* previous proximity */

    /* parameters for the smoothing algorithm */
    GraphireUSBSmoothRec smoothX, smoothY;
} GraphireUSBDeviceRec, *GraphireUSBDevicePtr;

typedef struct _GraphireUSBCommonRec
{
    char		*graphireUSBDevice;	/* device file name */
    int			graphireUSBSuppress;	/* transmit position if increment is superior */
    int			graphireUSBMaxX;	/* max X value */
    int			graphireUSBMaxY;	/* max Y value */
    int			graphireUSBMaxZ;	/* max Z value */
    int			graphireUSBResolX;	/* X resolution in points/inch */
    int			graphireUSBResolY;	/* Y resolution in points/inch */
    int			graphireUSBResolZ;	/* Z resolution in points/inch */
    LocalDevicePtr	*graphireUSBDevices;	/* array of all devices sharing the same port */
    int			graphireUSBNumDevices;	/* number of devices */
    GraphireUSBDevicePtr graphireUSBCurrentDevice;
    LocalDevicePtr      graphireUSBCurrentLocal;
    int			graphireUSBThreshold;	/* Threshold for counting pressure as a button */
    int			graphireUSBInitNumber;  /* magic number for the init phasis */
} GraphireUSBCommonRec, *GraphireUSBCommonPtr;


/* new function for USB device */
/* for a clean solution please put it into a header file */
struct cqueue* cq_init(struct cqueue*, int);
void cq_shutdown(struct cqueue *);
void cq_clear(struct cqueue *);
void cq_drop(struct cqueue *, int);
int cq_add(struct cqueue *, int);
int cq_get(struct cqueue *, int);
int cq_set(struct cqueue *, int, int);
int cq_size(struct cqueue *);
GraphireUSBSmoothRec* GraphireUSBSmoothInit(GraphireUSBSmoothRec*, int);
int xf86GraphireSmooth(int, int,GraphireUSBSmoothRec *);
GraphireUSBDevicePtr xf86GraphireUSBSwitchCurrentDevice(int , GraphireUSBCommonPtr);


/******************************************************************************
 * configuration stuff
 *****************************************************************************/
#define MOUSE_SECTION_NAME "gmouse"
#define STYLUS_SECTION_NAME "gstylus"
#define ERASER_SECTION_NAME "geraser"

#ifndef XFREE86_V4

#define PORT		1
#define DEVICENAME	2
#define THE_MODE	3
#define SUPPRESS	4
#define DEBUG_LEVEL     5
#define TILT_MODE	6
#define HISTORY_SIZE	7
#define ALWAYS_CORE	8
#define	KEEP_SHAPE	9
#define	TOP_X		10
#define	TOP_Y		11
#define	BOTTOM_X	12
#define	BOTTOM_Y	13
#define	SERIAL		14
#define	BAUD_RATE	15
#define	THRESHOLD	16
#define MAX_X		17
#define MAX_Y		18
#define MAX_Z		19
#define RESOLUTION_X	20
#define RESOLUTION_Y	21
#define RESOLUTION_Z	22

#if !defined(sun) || defined(i386)
static SymTabRec GraphireUSBTab[] = {
  { ENDSUBSECTION,	"endsubsection" },
  { PORT,		"port" },
  { DEVICENAME,		"devicename" },
  { THE_MODE,		"mode" },
  { SUPPRESS,		"suppress" },
  { DEBUG_LEVEL,	"debuglevel" },
  { TILT_MODE,		"tiltmode" },
  { HISTORY_SIZE,	"historysize" },
  { ALWAYS_CORE,	"alwayscore" },
  { KEEP_SHAPE,		"keepshape" },
  { TOP_X,		"topx" },
  { TOP_Y,		"topy" },
  { BOTTOM_X,		"bottomx" },
  { BOTTOM_Y,		"bottomy" },
  { SERIAL,		"serial" },
  { BAUD_RATE,		"baudrate" },
  { THRESHOLD,		"threshold" },
  { MAX_X,		"maxx" },
  { MAX_Y,		"maxy" },
  { MAX_Z,		"maxz" },
  { RESOLUTION_X,	"resolutionx" },
  { RESOLUTION_Y,	"resolutiony" },
  { RESOLUTION_Z,	"resolutionz" },
  { -1,			"" }
};

#define RELATIVE	1
#define ABSOLUTE	2

static SymTabRec ModeTabRec[] = {
  { RELATIVE,	"relative" },
  { ABSOLUTE,	"absolute" },
  { -1,		"" }
};

#endif
#endif /* Pre 3.9 headers */

/******************************************************************************
 * constant and macros declarations
 *****************************************************************************/
#define BUFFER_SIZE 256		/* size of reception buffer */
#define XI_GSTYLUS "GSTYLUS"	/* X device name for the stylus */
#define XI_GMOUSE "GMOUSE"	/* X device name for the mouse */
#define XI_GERASER "GERASER"	/* X device name for the eraser */
#define MAX_VALUE 100           /* number of positions */
#define MAXTRY 3                /* max number of try to receive magic number */
#define MAX_COORD_RES 1270.0	/* Resolution of the returned MaxX and MaxY */
#define INVALID_THRESHOLD 30000 /* Invalid threshold value used to test if
				 * the user configured it or not */

#define SYSCALL(call) while(((call) == -1) && (errno == EINTR))

#define mils(res) (res * 100 / 2.54) /* resolution */

/******************************************************************************
 * external declarations
 *****************************************************************************/
#ifndef XFREE86_V4

#if defined(sun) && !defined(i386)
#define ENQUEUE suneqEnqueue
#else
#define ENQUEUE xf86eqEnqueue

extern void xf86eqEnqueue(
#if NeedFunctionPrototypes
    xEventPtr /*e*/
#endif
);
#endif

extern void miPointerDeltaCursor(
#if NeedFunctionPrototypes
    int /*dx*/,
    int /*dy*/,
    unsigned long /*time*/
#endif
);

#endif /* pre 3.9 declarations */

#if NeedFunctionPrototypes
static LocalDevicePtr xf86GraphireUSBAllocateStylus(void);
static LocalDevicePtr xf86GraphireUSBAllocateMouse(void);
static LocalDevicePtr xf86GraphireUSBAllocateEraser(void);
#endif

#ifndef XFREE86_V4
#if !defined(sun) || defined(i386)
/*
 ***************************************************************************
 *
 * xf86GraphireUSBConfig --
 *	Configure the device.
 *
 ***************************************************************************
 */
static Bool
xf86GraphireUSBConfig(LocalDevicePtr    *array,
              int               inx,
              int               max,
	      LexPtr            val)
{
    LocalDevicePtr      dev = array[inx];
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr)(dev->private);
    GraphireUSBCommonPtr	common = priv->common;
    int			token;
    int			mtoken;
    
    DBG(1, ErrorF("xf86GraphireUSBConfig\n"));

    if (xf86GetToken(GraphireUSBTab) != PORT) {
	xf86ConfigError("PORT option must be the first option of a GraphireUSB SubSection");
    }
    
    if (xf86GetToken(NULL) != STRING)
	xf86ConfigError("Option string expected");
    else {
	int     loop;
		
	/* try to find another wacom device which share the same port */
	for(loop=0; loop<max; loop++) {
	    if (loop == inx)
		continue;
	    if ((array[loop]->device_config == xf86GraphireUSBConfig) &&
		(strcmp(((GraphireUSBDevicePtr)array[loop]->private)->common->graphireUSBDevice, val->str) == 0)) {
		DBG(2, ErrorF("xf86GraphireUSBConfig event port share between"
			      " %s and %s\n",
			      dev->name, array[loop]->name));
		xfree(common->graphireUSBDevices);
		xfree(common);
		common = priv->common = ((GraphireUSBDevicePtr) array[loop]->private)->common;
		common->graphireUSBNumDevices++;
		common->graphireUSBDevices = (LocalDevicePtr *) xrealloc(common->graphireUSBDevices,
								 sizeof(LocalDevicePtr) * common->graphireUSBNumDevices);
		common->graphireUSBDevices[common->graphireUSBNumDevices - 1] = dev;
		break;
	    }
	}
	if (loop == max) {
	    common->graphireUSBDevice = strdup(val->str);
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB port is %s\n", XCONFIG_GIVEN,
		       common->graphireUSBDevice);
	}
    }

    while ((token = xf86GetToken(GraphireUSBTab)) != ENDSUBSECTION) {
	switch(token) {
	case DEVICENAME:
	    if (xf86GetToken(NULL) != STRING)
		xf86ConfigError("Option string expected");
	    dev->name = strdup(val->str);
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB X device name is %s\n", XCONFIG_GIVEN,
		       dev->name);
	    break;	    
	    
	case THE_MODE:
	    mtoken = xf86GetToken(ModeTabRec);
	    if ((mtoken == EOF) || (mtoken == STRING) || (mtoken == NUMBER)) 
		xf86ConfigError("Mode type token expected");
	    else {
		switch (mtoken) {
		case ABSOLUTE:
		    priv->flags = priv->flags | ABSOLUTE_FLAG;
		    break;
		case RELATIVE:
		    priv->flags = priv->flags & ~ABSOLUTE_FLAG; 
		    break;
		default:
		    xf86ConfigError("Illegal Mode type");
		    break;
                }
                if (xf86Verbose)
                    ErrorF("%s GraphireUSB is in %s mode\n", XCONFIG_GIVEN,
                           (priv->flags & ABSOLUTE_FLAG) ?
                           "absolute" : "relative");
	    }
	    break;
	    
	case SUPPRESS:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
            if (val->num > MAX_SUPPRESS)
                xf86ConfigError("Suppress value too large");
	    common->graphireUSBSuppress = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB suppress value is %d\n", XCONFIG_GIVEN,
		       common->graphireUSBSuppress);      
	    break;
	    
	case DEBUG_LEVEL:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    debug_level = val->num;
	    if (xf86Verbose) {
#if DEBUG
		ErrorF("%s GraphireUSB debug level sets to %d\n", XCONFIG_GIVEN,
		       debug_level);      
#else
		ErrorF("%s GraphireUSB debug level not sets to %d because"
		       " debugging is not compiled\n", XCONFIG_GIVEN,
		       debug_level);      
#endif
	    }
	    break;

	case HISTORY_SIZE:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    dev->history_size = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB Motion history size is %d\n", XCONFIG_GIVEN,
		       dev->history_size);      
	    break;

	case ALWAYS_CORE:
	    xf86AlwaysCore(dev, TRUE);
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB device always stays core pointer\n",
		       XCONFIG_GIVEN);
	    break;

	case KEEP_SHAPE:
	    priv->flags |= KEEP_SHAPE_FLAG;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB keeps shape\n",
		       XCONFIG_GIVEN);
	    break;

	case TOP_X:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    priv->topX = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB top x = %d\n", XCONFIG_GIVEN, priv->topX);
	    break;

	case TOP_Y:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    priv->topY = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB top y = %d\n", XCONFIG_GIVEN, priv->topY);
	    break;

	case BOTTOM_X:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    priv->bottomX = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB bottom x = %d\n", XCONFIG_GIVEN, priv->bottomX);
	    break;

	case BOTTOM_Y:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    priv->bottomY = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB bottom y = %d\n", XCONFIG_GIVEN, priv->bottomY);
	    break;

	case THRESHOLD:
	    if (xf86GetToken(NULL) != STRING)
		xf86ConfigError("Option string expected");

	    common->graphireUSBThreshold = atoi(val->str);
	    
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB pressure threshold for button 1 = %d\n",
		       XCONFIG_GIVEN, common->graphireUSBThreshold);
	    break;

	case MAX_X:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    common->graphireUSBMaxX = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB max x = %d\n", XCONFIG_GIVEN, common->graphireUSBMaxX);
	    break;

	case MAX_Y:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    common->graphireUSBMaxY = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB max y = %d\n", XCONFIG_GIVEN, common->graphireUSBMaxY);
	    break;

	case MAX_Z:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    common->graphireUSBMaxZ = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB max y = %d\n", XCONFIG_GIVEN, common->graphireUSBMaxZ);
	    break;

	case RESOLUTION_X:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    common->graphireUSBResolX = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB resolution x = %d\n", XCONFIG_GIVEN, common->graphireUSBResolX);
	    break;

	case RESOLUTION_Y:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    common->graphireUSBResolY = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB resolution y = %d\n", XCONFIG_GIVEN, common->graphireUSBResolY);
	    break;

	case RESOLUTION_Z:
	    if (xf86GetToken(NULL) != NUMBER)
		xf86ConfigError("Option number expected");
	    common->graphireUSBResolZ = val->num;
	    if (xf86Verbose)
		ErrorF("%s GraphireUSB resolution y = %d\n", XCONFIG_GIVEN, common->graphireUSBResolZ);
	    break;

	case EOF:
	    FatalError("Unexpected EOF (missing EndSubSection)");
	    break;
	    
	default:
	    xf86ConfigError("GraphireUSB subsection keyword expected");
	    break;
	}
    }
    
    DBG(1, ErrorF("xf86GraphireUSBConfig name=%s\n", common->graphireUSBDevice));
    
    return Success;
}
#endif
#endif /* Pre 3.9 stuff */

/*
 ***************************************************************************
 *
 * xf86GraphireUSBConvert -- OK
 *	Convert valuators to X and Y.
 *
 ***************************************************************************
 */
static Bool
xf86GraphireUSBConvert(LocalDevicePtr	local,
	       int		first,
	       int		num,
	       int		v0,
	       int		v1,
	       int		v2,
	       int		v3,
	       int		v4,
	       int		v5,
	       int*		x,
	       int*		y)
{
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr) local->private;

    DBG(6, ErrorF("xf86GraphireUSBConvert\n"));

    if (first != 0 || num == 1)
      return FALSE;

#ifdef XFREE86_V4
    priv->factorX = ((double) miPointerCurrentScreen()->width)
	/ (priv->bottomX - priv->topX);
    priv->factorY = ((double) miPointerCurrentScreen()->height)
	/ (priv->bottomY - priv->topY);
#endif
    
    *x = v0 * priv->factorX;
    *y = v1 * priv->factorY;

    DBG(6, ErrorF("GraphireUSB converted v0=%d v1=%d to x=%d y=%d\n",
		  v0, v1, *x, *y));

    return TRUE;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBReverseConvert -- OK
 *	Convert X and Y to valuators.
 *
 ***************************************************************************
 */
static Bool
xf86GraphireUSBReverseConvert(LocalDevicePtr	local,
		      int		x,
		      int		y,
		      int		*valuators)
{
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr) local->private;

#ifdef XFREE86_V4
    priv->factorX = ((double) miPointerCurrentScreen()->width)
	/ (priv->bottomX - priv->topX);
    priv->factorY = ((double) miPointerCurrentScreen()->height)
	/ (priv->bottomY - priv->topY);
#endif
    
    valuators[0] = x / priv->factorX;
    valuators[1] = y / priv->factorY;

    DBG(6, ErrorF("GraphireUSB converted x=%d y=%d to v0=%d v1=%d\n", x, y,
		  valuators[0], valuators[1]));

    return TRUE;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBSendButtons -- OK
 *	Send button events by comparing the current button mask with the
 *      previous one.
 *
 ***************************************************************************
 */
static void
xf86GraphireUSBSendButtons(LocalDevicePtr	local,
		   int                  buttons,
		   int                  rx,
		   int                  ry,
		   int                  rz)
		
{
    int             button;
    GraphireUSBDevicePtr  priv = (GraphireUSBDevicePtr) local->private;

    for (button=1; button<=5; button++) {
	int mask = 1 << (button-1);
	
	if ((mask & priv->oldButtons) != (mask & buttons)) {
	    DBG(4, ErrorF("xf86GraphireUSBSendButtons button=%d state=%d\n",
			  button, (buttons & mask) != 0));
	    xf86PostButtonEvent(local->dev,
				(priv->flags & ABSOLUTE_FLAG),
				button, (buttons & mask) != 0,
				0, 3, rx, ry, rz);
	}
    }
}

/* smoothing helper routines */

/* Initialize circular queue */
struct cqueue* cq_init(struct cqueue *cq, int size)
{
	cq->queue = (int*)malloc(size * sizeof(int));
	cq->qmax = size;
	cq->qsize = 0;
	cq->tail = 0;

	return cq;
}

/* Free resources allocated in the queue; does not free the cqueue structure
 * itself */
void cq_shutdown(struct cqueue *cq)
{
	free(cq->queue);
}

/* Empty the queue */
void cq_clear(struct cqueue *cq)
{
	cq->tail = cq->qsize = 0;
}

/* Shorten the queue of count values, deleting the older ones */
void cq_drop(struct cqueue *cq, int count)
{
	cq->qsize -= count;
	cq->tail = (cq->tail + count) % cq->qmax;
}

/* Add item at the end of the queue */
int cq_add(struct cqueue *cq, int item)
{
	if (cq->qsize < cq->qmax)
		cq->queue[(cq->tail + cq->qsize++) % cq->qmax] = item;
	else
	{
		cq->queue[cq->tail] = item;
		cq->tail = (cq->tail + 1) % cq->qsize;
	}
	return item;
}

/* Get the idx-th item from the queue */
int cq_get(struct cqueue *cq, int idx)
{
	return cq->queue[(cq->tail + idx) % cq->qmax];
}

/* Set the idx-th item in the queue */
int cq_set(struct cqueue *cq, int idx, int val)
{
	return cq->queue[(cq->tail + idx) % cq->qmax] = val;
}

/* Get the number of items in the queue */
int cq_size(struct cqueue *cq)
{
	return cq->qsize;
}

GraphireUSBSmoothRec* GraphireUSBSmoothInit(GraphireUSBSmoothRec* smooth, int suppress)
{
	cq_init(&smooth->cq, suppress);
	smooth->average = 0;
	return smooth;
}

/*
 ***************************************************************************
 *
 * xf86GraphireSmooth
 *	Averages x or y values reported from the tablet to
 *      control jitter
 *
 ***************************************************************************
 */

int xf86GraphireSmooth(int newVal, int suppress, GraphireUSBSmoothRec *smooth)
{
	int drop;
	int i;

	if (cq_size(&smooth->cq) == 0) {
		return smooth->average = cq_add(&smooth->cq, newVal);
    }

	/* drop older values; the larger the last move, the more old values
	 * dropped */
	drop = abs(smooth->average - newVal) - suppress/4;
	/* lv->log("inavg: %i, size: %i, newVal: %i, drop: %i", average, cq.size(), newVal, drop); */
	if (drop > 0) {
		if (drop < cq_size(&smooth->cq)) {
			cq_drop(&smooth->cq, drop);
		} else {
			cq_clear(&smooth->cq);
        }
    }
	cq_add(&smooth->cq, newVal);
    

	/* compute new average and return it */
	smooth->average = 0;
	for (i = 0; i < cq_size(&smooth->cq); ++i)
		smooth->average += cq_get(&smooth->cq, i);
	smooth->average /= cq_size(&smooth->cq);

	return smooth->average;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBSendEvents -- XXX
 *	Send events according to the device state.
 *
 ***************************************************************************
 */
static void
xf86GraphireUSBSendEvents(LocalDevicePtr	local,
		  int			type,
		  int			is_button,
		  int			is_proximity,
		  int			x,
		  int			y,
		  int			z,
		  int			buttons)
{
    GraphireUSBDevicePtr priv;
    GraphireUSBCommonPtr common;
    int			 rx, ry, rz;
    int			 is_core_pointer, is_absolute;

    /* catch unconfigured devices */
    if (!local) {
	ErrorF("xf86GraphireUSBSendEvents: attempt to use unconfigured device.\n");
	return;
    }

    priv = (GraphireUSBDevicePtr) local->private;
    common = priv->common;


    /* Translate coordinates according to Top and Bottom points
     * if we are outside the zone do as a ProximityOut event.
     */

    if (x > priv->bottomX) {
	is_proximity = FALSE;
	buttons = 0;
	x = priv->bottomX;
    }
	
    if (y > priv->bottomY) {
	is_proximity = FALSE;
	buttons = 0;
	y = priv->bottomY;
    }

    DBG(10, ErrorF("topX=%d topY=%d\n", priv->topX, priv->topY));

    x = x - priv->topX;
    y = y - priv->topY;

    if (x < 0) {
	is_proximity = FALSE;
	buttons = 0;
	x = 0;
    }

    if (y < 0) {
	is_proximity = FALSE;
	buttons = 0;
	y = 0;
    }

    is_absolute = (priv->flags & ABSOLUTE_FLAG);
    is_core_pointer = xf86IsCorePointer(local->dev);

    /* Do the smoothing algorithm */
    if (is_proximity)
    {
        x = xf86GraphireSmooth(x, common->graphireUSBSuppress, &priv->smoothX);
        y = xf86GraphireSmooth(y, common->graphireUSBSuppress, &priv->smoothY);
    }
    
    /* Hardware filtering isn't working on Graphire so we do it here.
     */
    if (((is_proximity && priv->oldProximity) ||
	 ((is_proximity == 0) && (priv->oldProximity == 0))) &&
	(buttons == priv->oldButtons) &&
	(ABS(x - priv->oldX) <= 1) &&
	(ABS(y - priv->oldY) <= 1) &&
	(ABS(z - priv->oldZ) < 3)) {
	
	DBG(10, ErrorF("Graphire filtered\n"));

	return;
    }
		
    /* sets rx and ry according to the mode */
    if (is_absolute) {
	rx = x;
	ry = y;
	rz = z;
    } else {
      /*ErrorF("x %d oldX %d Y %d oldY %d z %d oldZ %d \n",
        x, priv->oldX, y, priv->oldY, z, priv->oldZ);*/
      if (z < 27)
      {
        rx = 0;
        ry = 0;
        priv->oldX = x;
        priv->oldY = y;
      }
      else
      {
        if (z - priv->oldZ > 0)
        {
          rx = 0;
          ry = 0;
          priv->oldX = x;
          priv->oldY = y;
        }
        else
        {
          rx = x - priv->oldX;
          ry = y - priv->oldY;
        }
      }
      rz = z - priv->oldZ;
    }

    /* coordinates are ready we can send events */
    if (is_proximity) {

	if (!priv->oldProximity) {
	    xf86PostProximityEvent(local->dev, 1, 0, 3, rx, ry, z);

	    priv->flags |= FIRST_TOUCH_FLAG;
	    DBG(10, ErrorF("xf86GraphireUSBSendEvents FIRST_TOUCH_FLAG set\n"));
	}

	if ((priv->oldX != x) ||
	    (priv->oldY != y) ||
	    (priv->oldZ != z)) {
	    if (!is_absolute && (priv->flags & FIRST_TOUCH_FLAG)) {
		priv->flags ^= FIRST_TOUCH_FLAG;
		DBG(10, ErrorF("xf86GraphireUSBSendEvents FIRST_TOUCH_FLAG unset\n"));
	    } else {
		xf86PostMotionEvent(local->dev, is_absolute, 0, 3, rx, ry, rz);
	    }
	}

	if (priv->oldButtons != buttons) {
	    xf86GraphireUSBSendButtons (local, buttons, rx, ry, rz);
	}

	priv->oldProximity = 1;
	priv->oldButtons = buttons;
	priv->oldX = x;
	priv->oldY = y;
	priv->oldZ = z;
    }
    else { /* !PROXIMITY */
	/* reports button up when the device has been down and becomes
	   out of proximity (but only if device is in absolute mode,
           ie. not likely to be a mouse) */
	if (priv->oldButtons && is_absolute) {
            xf86GraphireUSBSendButtons (local, 0, rx, ry, rz);
            priv->oldButtons = 0;
	}
	if (priv->oldProximity) {
	    xf86PostProximityEvent(local->dev, 0, 0, 3, rx, ry, rz);
	}
	priv->oldProximity = 0;
    }
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBFindDevPtrByType -- OK
 *	Switch over to the device indicated through the type id,
 *      send proximity in and out events where appropriate.
 *      Returns the new device selected (may be 0).
 *
 ***************************************************************************
 */

GraphireUSBDevicePtr
xf86GraphireUSBSwitchCurrentDevice(int typeID, GraphireUSBCommonPtr common)
{
    int i;
    GraphireUSBDevicePtr
	newDevice = 0,
	oldDevice = common->graphireUSBCurrentDevice;
    LocalDevicePtr
	newLocal = 0,
	oldLocal = common->graphireUSBCurrentLocal;

    if (oldDevice && (DEVICE_ID(oldDevice->flags) == typeID))
	return oldDevice; /* no change */

    if (oldDevice) {
	/* send proximity out event */
	xf86GraphireUSBSendEvents(oldLocal,
				  oldDevice->flags,
				  0,
				  0,
				  oldDevice->oldX,
				  oldDevice->oldY,
				  oldDevice->oldZ,
				  oldDevice->oldButtons);
    }

    for (i=0; i<common->graphireUSBNumDevices; i++) {
	newLocal = common->graphireUSBDevices[i];
	newDevice = (GraphireUSBDevicePtr)newLocal->private;
	if (DEVICE_ID(newDevice->flags) == typeID)
	    break;
    }
    if (i == common->graphireUSBNumDevices) {
	newDevice = 0;
	newLocal = 0;
    }

    if (newDevice) {
	/* send proximity in event */
	xf86GraphireUSBSendEvents(newLocal,
				  newDevice->flags,
				  0,
				  1,
				  newDevice->oldX,
				  newDevice->oldY,
				  newDevice->oldZ,
				  newDevice->oldButtons);
    }

    common->graphireUSBCurrentDevice = newDevice; /* might be 0! */
    common->graphireUSBCurrentLocal  = newLocal;  /* might be 0! */

    return newDevice;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBReadInput -- Mostly OK.
 *	Read the new events from the device, and enqueue them.
 *      This will crash your X server if you don't register a device
 *      for all three Graphire input devices (Mouse, Stylus, Eraser).
 *      I'll fix that later.
 *
 ***************************************************************************
 */
static void
xf86GraphireUSBReadInput(LocalDevicePtr         local)
{
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr) local->private;
    GraphireUSBCommonPtr	common = priv->common;
    unsigned char	buffer[BUFFER_SIZE];
    int len, loop;
    struct input_event* usb_input_event;

#define SEEN_X        1
#define SEEN_Y        2
#define SEEN_PRESSURE 4
#define SEEN_DISTANCE 8
    int events_seen;
    int new_x = 0, new_y = 0, new_pressure = 0, new_distance = 0;

    DBG(7, ErrorF("xf86GraphireUSBReadInput BEGIN device=%s fd=%d\n",
		  common->graphireUSBDevice, local->fd));

    SYSCALL(len = read(local->fd, buffer, sizeof(buffer)));

    if (len <= 0) {
	ErrorF("Error reading GraphireUSB event device : %s\n", strerror(errno));
	return;
    } else {
	DBG(10, ErrorF("xf86GraphireUSBReadInput read %d bytes\n", len));
    }

    events_seen = 0;
    for (loop=0; loop<len; loop+=(sizeof(struct input_event))) {
	usb_input_event = (struct input_event *)(&buffer[loop]);

	switch (usb_input_event->type) {
	case EV_KEY:
	    /* button event (basically everything except valuators) */
	    switch (usb_input_event->code) {
	    case BTN_LEFT:
		/* Left button */
		if (!xf86GraphireUSBSwitchCurrentDevice(MOUSE_ID, common))
		    break;
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  MOUSE_ID, 1, 1,
		  (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_DISTANCE) ?
  		    new_distance :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value) ?
			  common->graphireUSBCurrentDevice->oldButtons | 1 :
			  common->graphireUSBCurrentDevice->oldButtons & !1);
		events_seen = 0;
		break;
	    case BTN_RIGHT:
		/* Right button */
		if (!xf86GraphireUSBSwitchCurrentDevice(MOUSE_ID, common))
		    break;
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  MOUSE_ID, 1, 1,
		  (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_DISTANCE) ?
  		    new_distance :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value) ?
			  common->graphireUSBCurrentDevice->oldButtons | 4 :
			  common->graphireUSBCurrentDevice->oldButtons & !4);
		events_seen = 0;
		break;
	    case BTN_MIDDLE:
                /* Middle button */
		if (!xf86GraphireUSBSwitchCurrentDevice(MOUSE_ID, common))
		    break;
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  MOUSE_ID, 1, 1,
		  (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_DISTANCE) ?
  		    new_distance :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value) ?
			  common->graphireUSBCurrentDevice->oldButtons | 2 :
			  common->graphireUSBCurrentDevice->oldButtons & !2);
		events_seen = 0;
		break;

	    case BTN_TOOL_PEN:
		/* Proximity: Stylus */
		xf86GraphireUSBSwitchCurrentDevice(
		    (usb_input_event->value) ? STYLUS_ID : 0,
		    common);
		if (common->graphireUSBCurrentDevice && events_seen)
		    xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		      STYLUS_ID, 1, 1,
		      (events_seen & SEEN_X) ?
  		        new_x :
		        common->graphireUSBCurrentDevice->oldX,
		      (events_seen & SEEN_Y) ?
  		        new_y :
		        common->graphireUSBCurrentDevice->oldY,
		      (events_seen & SEEN_PRESSURE) ?
  		        new_pressure :
		        common->graphireUSBCurrentDevice->oldZ,
			common->graphireUSBCurrentDevice->oldButtons);
		events_seen = 0;
		break;
	    case BTN_TOOL_RUBBER:
		/* Proximity: Eraser */
		xf86GraphireUSBSwitchCurrentDevice(
		    (usb_input_event->value) ? ERASER_ID : 0,
		    common);
		if (common->graphireUSBCurrentDevice && events_seen)
		    xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		      ERASER_ID, 1, 1,
		      (events_seen & SEEN_X) ?
  		        new_x :
		        common->graphireUSBCurrentDevice->oldX,
		      (events_seen & SEEN_Y) ?
  		        new_y :
		        common->graphireUSBCurrentDevice->oldY,
		      (events_seen & SEEN_PRESSURE) ?
  		        new_pressure :
		        common->graphireUSBCurrentDevice->oldZ,
			common->graphireUSBCurrentDevice->oldButtons);
		events_seen = 0;
		break;
	    case BTN_TOOL_MOUSE:
		/* Proximity: Mouse */
		xf86GraphireUSBSwitchCurrentDevice(
		    (usb_input_event->value) ? MOUSE_ID : 0,
		    common);
		if (common->graphireUSBCurrentDevice && events_seen)
		    xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		      MOUSE_ID, 1, 1,
		      (events_seen & SEEN_X) ?
  		        new_x :
		        common->graphireUSBCurrentDevice->oldX,
		      (events_seen & SEEN_Y) ?
  		        new_y :
		        common->graphireUSBCurrentDevice->oldY,
		      (events_seen & SEEN_DISTANCE) ?
  		        new_distance :
		        common->graphireUSBCurrentDevice->oldZ,
			common->graphireUSBCurrentDevice->oldButtons);
		events_seen = 0;
		break;

	    case BTN_TOUCH:
		/* Stylus/Eraser tip */
		if (common->graphireUSBCurrentDevice) {
		    xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		      DEVICE_ID(common->graphireUSBCurrentDevice->flags),
		      1, 1,
		      (events_seen & SEEN_X) ?
  		        new_x :
		        common->graphireUSBCurrentDevice->oldX,
		      (events_seen & SEEN_Y) ?
  		        new_y :
		        common->graphireUSBCurrentDevice->oldY,
		      (events_seen & SEEN_PRESSURE) ?
  		        new_pressure :
		        common->graphireUSBCurrentDevice->oldZ,
		      (usb_input_event->value) ?
			  common->graphireUSBCurrentDevice->oldButtons | 1 :
			  common->graphireUSBCurrentDevice->oldButtons & !1);
		}
		events_seen = 0;
		break;
	    case BTN_STYLUS:
		/* Stylus button 1 */
		if (!xf86GraphireUSBSwitchCurrentDevice(STYLUS_ID, common))
		    break;
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  STYLUS_ID, 1, 1,
 	          (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_PRESSURE) ?
  		    new_pressure :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value) ?
			  common->graphireUSBCurrentDevice->oldButtons | 2 :
			  common->graphireUSBCurrentDevice->oldButtons & !2);
		events_seen = 0;
		break;
	    case BTN_STYLUS2:
		/* Stylus button 2 */
		if (!xf86GraphireUSBSwitchCurrentDevice(STYLUS_ID, common))
		    break;
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  STYLUS_ID, 1, 1,
		  (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_PRESSURE) ?
  		    new_pressure :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value) ?
			  common->graphireUSBCurrentDevice->oldButtons | 4 :
			  common->graphireUSBCurrentDevice->oldButtons & !4);
		events_seen = 0;
		break;

	    default:
		/* seems we forgot something... */
		ErrorF("Graphire: Huh? (%d, %d, %d)\n", usb_input_event->type, usb_input_event->code, usb_input_event->value);
	    }
	    break;

	case EV_REL:
	    /* relative mode value (on graphire, only the mouse wheel) */
	    /* we fake button events for this */
	    switch (usb_input_event->code) {
	    case REL_WHEEL:
		/* Wheel */
		if (!xf86GraphireUSBSwitchCurrentDevice(MOUSE_ID, common))
		    break;
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  MOUSE_ID, 1, 1,
		  (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_DISTANCE) ?
  		    new_distance :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value == 1) ?
			  common->graphireUSBCurrentDevice->oldButtons | 16 :
			  common->graphireUSBCurrentDevice->oldButtons |  8);
		xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		  MOUSE_ID, 1, 1,
		  (events_seen & SEEN_X) ?
  		    new_x :
		    common->graphireUSBCurrentDevice->oldX,
		  (events_seen & SEEN_Y) ?
  		    new_y :
		    common->graphireUSBCurrentDevice->oldY,
		  (events_seen & SEEN_DISTANCE) ?
  		    new_distance :
		    common->graphireUSBCurrentDevice->oldZ,
		  (usb_input_event->value == 1) ?
			  common->graphireUSBCurrentDevice->oldButtons & !16 :
			  common->graphireUSBCurrentDevice->oldButtons &  !8);
		events_seen = 0;
		break;

	    default:
		/* Huh? */
		ErrorF("Graphire: Huh? (%d, %d, %d)\n", usb_input_event->type, usb_input_event->code, usb_input_event->value);
		break;
	    }
	    break;

	case EV_ABS:
	    /* absolute mode value */
	    switch (usb_input_event->code) {
	    case ABS_X:
		/* X axis */
		if (common->graphireUSBCurrentDevice) {
		    if (events_seen & SEEN_X) {
			xf86GraphireUSBSendEvents(
                          common->graphireUSBCurrentLocal,
		          DEVICE_ID(common->graphireUSBCurrentDevice->flags),
		          FALSE, 1,
		          (events_seen & SEEN_X) ?
  		            new_x :
		            common->graphireUSBCurrentDevice->oldX,
		          (events_seen & SEEN_Y) ?
  		            new_y :
		            common->graphireUSBCurrentDevice->oldY,
		          (events_seen & SEEN_PRESSURE) ?
  		            new_pressure :
		            common->graphireUSBCurrentDevice->oldZ,
		          common->graphireUSBCurrentDevice->oldButtons);
			events_seen = 0;
		    }
		    new_x = usb_input_event->value;
		    events_seen |= SEEN_X;
		}
		break;
	    case ABS_Y:
		/* Y axis */
		if (common->graphireUSBCurrentDevice) {
		    if (events_seen & SEEN_Y) {
			xf86GraphireUSBSendEvents(
			  common->graphireUSBCurrentLocal,
		          DEVICE_ID(common->graphireUSBCurrentDevice->flags),
		          FALSE, 1,
		          (events_seen & SEEN_X) ?
  		            new_x :
		            common->graphireUSBCurrentDevice->oldX,
		          (events_seen & SEEN_Y) ?
  		            new_y :
		            common->graphireUSBCurrentDevice->oldY,
		          (events_seen & SEEN_PRESSURE) ?
  		            new_pressure :
		            common->graphireUSBCurrentDevice->oldZ,
		          common->graphireUSBCurrentDevice->oldButtons);
			events_seen = 0;
		    }
		    new_y = usb_input_event->value;
		    events_seen |= SEEN_Y;
		}
		break;

	    case ABS_PRESSURE:
		/* Pressure */
		if (common->graphireUSBCurrentDevice) {
		    if (events_seen & SEEN_PRESSURE) {
		        xf86GraphireUSBSendEvents(
			  common->graphireUSBCurrentLocal,
		          DEVICE_ID(common->graphireUSBCurrentDevice->flags),
		          FALSE, 1,
		          (events_seen & SEEN_X) ?
  		            new_x :
		            common->graphireUSBCurrentDevice->oldX,
		          (events_seen & SEEN_Y) ?
  		            new_y :
		            common->graphireUSBCurrentDevice->oldY,
		          (events_seen & SEEN_PRESSURE) ?
  		            new_pressure :
		            common->graphireUSBCurrentDevice->oldZ,
		          common->graphireUSBCurrentDevice->oldButtons);
			events_seen = 0;
		    }
		    new_pressure = usb_input_event->value;
		    events_seen |= SEEN_PRESSURE;
		}
		break;
	    case ABS_DISTANCE:
		/* Distance */
		if (!xf86GraphireUSBSwitchCurrentDevice(MOUSE_ID, common))
		    break;
		if (events_seen & SEEN_DISTANCE) {
		    xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
		      MOUSE_ID, FALSE, 1,
		      (events_seen & SEEN_X) ?
  		        new_x :
		        common->graphireUSBCurrentDevice->oldX,
		      (events_seen & SEEN_Y) ?
  		        new_y :
		        common->graphireUSBCurrentDevice->oldY,
		      (events_seen & SEEN_DISTANCE) ?
  		        new_distance :
		        common->graphireUSBCurrentDevice->oldZ,
		      common->graphireUSBCurrentDevice->oldButtons);
		    events_seen = 0;
		}
		new_distance = usb_input_event->value;
		events_seen |= SEEN_DISTANCE;
		break;

	    default:
		/* What the heck was that? */
		ErrorF("Graphire: Huh? (%d, %d, %d)\n", usb_input_event->type, usb_input_event->code, usb_input_event->value);
		break;
	    }
	    break;

	default:
	    /* huh? we didn't expect the spanish inquisition! */
	    ErrorF("Graphire: Huh? (%d, %d, %d)\n", usb_input_event->type, usb_input_event->code, usb_input_event->value);
	    break;
	}
    }
    /* sweep up leftovers */
    if (common->graphireUSBCurrentDevice && events_seen) {
	xf86GraphireUSBSendEvents(common->graphireUSBCurrentLocal,
          DEVICE_ID(common->graphireUSBCurrentDevice->flags),
          FALSE, 1,
          (events_seen & SEEN_X) ?
            new_x :
            common->graphireUSBCurrentDevice->oldX,
          (events_seen & SEEN_Y) ?
            new_y :
            common->graphireUSBCurrentDevice->oldY,
	  (DEVICE_ID(common->graphireUSBCurrentDevice->flags) == MOUSE_ID) ?
            ((events_seen & SEEN_DISTANCE) ?
  	       new_distance :
	     common->graphireUSBCurrentDevice->oldZ) :
            ((events_seen & SEEN_PRESSURE) ?
               new_pressure :
               common->graphireUSBCurrentDevice->oldZ),
          common->graphireUSBCurrentDevice->oldButtons);
    }
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBControlProc -- OK
 *
 ***************************************************************************
 */
static void
xf86GraphireUSBControlProc(DeviceIntPtr	device,
		   PtrCtrl	*ctrl)
{
  DBG(2, ErrorF("xf86GraphireUSBControlProc\n"));
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBOpen -- OK
 *
 ***************************************************************************
 */
static Bool
xf86GraphireUSBOpen(LocalDevicePtr	local)
{
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr)local->private;
    GraphireUSBCommonPtr	common = priv->common;

    DBG(1, ErrorF("opening %s\n", common->graphireUSBDevice));

#ifdef XFREE86_V4
    local->fd = xf86OpenSerial(local->options);
#else
    SYSCALL(local->fd = open(common->graphireUSBDevice, O_RDWR|O_NDELAY, 0));
#endif
    if (local->fd < 0) {
	ErrorF("Error opening %s : %s\n", common->graphireUSBDevice, strerror(errno));
	return !Success;
    }

    common->graphireUSBMaxX = 10206;
    common->graphireUSBMaxY = 7422;
    common->graphireUSBMaxZ = 511; /* FIXME: 31 for mice */
    common->graphireUSBResolX = 1270; /* default value */
    common->graphireUSBResolY = 1270; /* default value */

    DBG(2, ErrorF("setup is max X=%d max Y=%d resol X=%d resol Y=%d\n",
		  common->graphireUSBMaxX, common->graphireUSBMaxY, common->graphireUSBResolX,
		  common->graphireUSBResolY));

    if (common->graphireUSBSuppress < 0) {
	int	xratio = common->graphireUSBMaxX/screenInfo.screens[0]->width;
	int	yratio = common->graphireUSBMaxY/screenInfo.screens[0]->height;
	
	common->graphireUSBSuppress = (xratio > yratio) ? yratio : xratio;
    }

    if (common->graphireUSBSuppress > 100) {
	common->graphireUSBSuppress = 99;
    }

    return Success;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBOpenDevice -- OK
 *	Open the physical device and init information structs.
 *
 ***************************************************************************
 */
static int
xf86GraphireUSBOpenDevice(DeviceIntPtr       pGraphireUSB)
{
    LocalDevicePtr	local = (LocalDevicePtr)pGraphireUSB->public.devicePrivate;
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr)PRIVATE(pGraphireUSB);
    GraphireUSBCommonPtr	common = priv->common;
    double		screenRatio, tabletRatio;
    int			gap;
    int			loop;

    if (local->fd < 0) {
        if (common->graphireUSBInitNumber > 2 ||
	    priv->initNumber == common->graphireUSBInitNumber) {
	    if (xf86GraphireUSBOpen(local) != Success) {
	        if (local->fd >= 0) {
		    SYSCALL(close(local->fd));
	        }
	        local->fd = -1;
	    }
	    else {
	        /* report the file descriptor to all devices */
	        for(loop=0; loop<common->graphireUSBNumDevices; loop++) {
		    common->graphireUSBDevices[loop]->fd = local->fd;
	        }
	    }
	    common->graphireUSBInitNumber++;
	    priv->initNumber = common->graphireUSBInitNumber;
	}
	else {
	  priv->initNumber = common->graphireUSBInitNumber;
	}
    }

    if (local->fd != -1 &&
	priv->factorX == 0.0) {
	
	if (priv->bottomX == 0) priv->bottomX = common->graphireUSBMaxX;

	if (priv->bottomY == 0) priv->bottomY = common->graphireUSBMaxY;

	/* Verify Box validity */

	if (priv->topX > common->graphireUSBMaxX ||
	    priv->topX < 0) {
	    ErrorF("GraphireUSB invalid TopX (%d) reseting to 0\n", priv->topX);
	    priv->topX = 0;
	}

	if (priv->topY > common->graphireUSBMaxY ||
	    priv->topY < 0) {
	    ErrorF("GraphireUSB invalid TopY (%d) reseting to 0\n", priv->topY);
	    priv->topY = 0;
	}

	if (priv->bottomX > common->graphireUSBMaxX ||
	    priv->bottomX < priv->topX) {
	    ErrorF("GraphireUSB invalid BottomX (%d) reseting to %d\n",
		   priv->bottomX, common->graphireUSBMaxX);
	    priv->bottomX = common->graphireUSBMaxX;
	}

	if (priv->bottomY > common->graphireUSBMaxY ||
	    priv->bottomY < priv->topY) {
	    ErrorF("GraphireUSB invalid BottomY (%d) reseting to %d\n",
		   priv->bottomY, common->graphireUSBMaxY);
	    priv->bottomY = common->graphireUSBMaxY;
	}

	/* Calculate the ratio according to KeepShape, TopX and TopY */

	if (priv->flags & KEEP_SHAPE_FLAG) {
	    screenRatio = ((double) screenInfo.screens[0]->width)
		/ screenInfo.screens[0]->height;

	    tabletRatio = ((double) (common->graphireUSBMaxX - priv->topX))
		/ (common->graphireUSBMaxY - priv->topY);

	    DBG(2, ErrorF("screenRatio = %.3g, tabletRatio = %.3g\n",
			  screenRatio, tabletRatio));

	    if (screenRatio > tabletRatio) {
		gap = common->graphireUSBMaxY * (1 - tabletRatio/screenRatio);
		priv->bottomX = common->graphireUSBMaxX;
		priv->bottomY = common->graphireUSBMaxY - gap;
	    } else {
		gap = common->graphireUSBMaxX * (1 - screenRatio/tabletRatio);
		priv->bottomX = common->graphireUSBMaxX - gap;
		priv->bottomY = common->graphireUSBMaxY;
	    }
	}
	priv->factorX = ((double) screenInfo.screens[0]->width)
	    / (priv->bottomX - priv->topX);
	priv->factorY = ((double) screenInfo.screens[0]->height)
	    / (priv->bottomY - priv->topY);

	if (xf86Verbose)
	    ErrorF("%s GraphireUSB tablet top X=%d top Y=%d "
		   "bottom X=%d bottom Y=%d\n",
		   XCONFIG_PROBED, priv->topX, priv->topY,
		   priv->bottomX, priv->bottomY);
	
	DBG(2, ErrorF("X factor = %.3g, Y factor = %.3g\n",
		      priv->factorX, priv->factorY));
    }

    /* Initialize smoothing algorithm */
    GraphireUSBSmoothInit(&priv->smoothX, common->graphireUSBSuppress);
    GraphireUSBSmoothInit(&priv->smoothY, common->graphireUSBSuppress);
        
    /* Check threshold correctness */
    DBG(2, ErrorF("Threshold=%d\n", common->graphireUSBThreshold));

    if (common->graphireUSBThreshold > ((common->graphireUSBMaxZ / 2) - 1) ||
	common->graphireUSBThreshold < - (common->graphireUSBMaxZ / 2)) {
	if (xf86Verbose &&
	    common->graphireUSBThreshold != INVALID_THRESHOLD)
	    ErrorF("%s GraphireUSB invalid threshold %d. Reset to %d\n",
		   XCONFIG_PROBED, common->graphireUSBThreshold, - (common->graphireUSBMaxZ / 3));
	common->graphireUSBThreshold = - (common->graphireUSBMaxZ / 3);
    }
    DBG(2, ErrorF("New threshold=%d\n", common->graphireUSBThreshold));

    /* Set the real values */
    InitValuatorAxisStruct(pGraphireUSB,
			   0,
			   0, /* min val */
			   priv->bottomX - priv->topX, /* max val */
			   mils(common->graphireUSBResolX), /* resolution */
			   0, /* min_res */
			   mils(common->graphireUSBResolX)); /* max_res */
    InitValuatorAxisStruct(pGraphireUSB,
			   1,
			   0, /* min val */
			   priv->bottomY - priv->topY, /* max val */
			   mils(common->graphireUSBResolY), /* resolution */
			   0, /* min_res */
			   mils(common->graphireUSBResolY)); /* max_res */
    InitValuatorAxisStruct(pGraphireUSB,
			   2,
			   0, /* min val */
			   common->graphireUSBMaxZ, /* max val */
			   mils(common->graphireUSBResolZ), /* resolution */
			   0, /* min_res */
			   mils(common->graphireUSBResolZ)); /* max_res */

    return (local->fd != -1);
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBClose --
 *
 ***************************************************************************
 */
static void
xf86GraphireUSBClose(LocalDevicePtr	local)
{
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr)local->private;
    GraphireUSBCommonPtr	common = priv->common;
    int			loop;
    int			num = 0;

    for(loop=0; loop<common->graphireUSBNumDevices; loop++) {
	if (common->graphireUSBDevices[loop]->fd >= 0) {
	    num++;
	}
    }
    DBG(4, ErrorF("GraphireUSB number of open devices = %d\n", num));

    if (num == 1) {		
	SYSCALL(close(local->fd));
    }

    local->fd = -1;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBProc -- OK
 *      Handle the initialization, etc. of a wacom
 *
 ***************************************************************************
 */
static int
xf86GraphireUSBProc(DeviceIntPtr       pGraphireUSB,
	    int                what)
{
    CARD8                 map[(32 << 4) + 1];
    int                   nbaxes = 0;
    int                   nbbuttons = 0;
    int                   loop;
    LocalDevicePtr        local = (LocalDevicePtr)pGraphireUSB->public.devicePrivate;
    GraphireUSBDevicePtr        priv = (GraphireUSBDevicePtr)PRIVATE(pGraphireUSB);

    DBG(2, ErrorF("BEGIN xf86GraphireUSBProc dev=0x%x priv=0x%x type=%s flags=%d what=%d\n",
		  pGraphireUSB, priv, (DEVICE_ID(priv->flags) == STYLUS_ID) ? "stylus" :
		  (DEVICE_ID(priv->flags) == MOUSE_ID) ? "mouse" : "eraser",
		  priv->flags, what));

    switch (what)
	{
	case DEVICE_INIT:
	    DBG(1, ErrorF("xf86GraphireUSBProc pGraphireUSB=0x%x what=INIT\n", pGraphireUSB));

	    switch(DEVICE_ID(priv->flags)) {
	    case ERASER_ID:
		nbaxes = 3;    /* X, Y, Pressure */
		nbbuttons = 1; /* touch */
		break;
	    case STYLUS_ID:
		nbaxes = 3;    /* X, Y, Pressure */
		nbbuttons = 3; /* touch, stylus, stylus2 */
		break;
	    case MOUSE_ID:
		nbaxes = 3;    /* X, Y, Distance */
		nbbuttons = 5; /* left, middle, right, wheel_up, wheel_down */
	    default:
		/* no such device */
		break;
	    }
	
	    for(loop=1; loop<=nbbuttons; loop++) map[loop] = loop;

	    if (InitButtonClassDeviceStruct(pGraphireUSB,
					    nbbuttons,
					    map) == FALSE) {
		ErrorF("unable to allocate Button class device\n");
		return !Success;
	    }

	    if (InitFocusClassDeviceStruct(pGraphireUSB) == FALSE) {
		ErrorF("unable to init Focus class device\n");
		return !Success;
	    }

	    if (InitPtrFeedbackClassDeviceStruct(pGraphireUSB,
						 xf86GraphireUSBControlProc) == FALSE) {
		ErrorF("unable to init ptr feedback\n");
		return !Success;
	    }
	
	    if (InitProximityClassDeviceStruct(pGraphireUSB) == FALSE) {
		ErrorF("unable to init proximity class device\n");
		return !Success;
	    }

	    if (InitValuatorClassDeviceStruct(pGraphireUSB,
					      nbaxes,
					      xf86GetMotionEvents,
					      local->history_size,
					      ((priv->flags & ABSOLUTE_FLAG)
					      ? Absolute : Relative) |
					      OutOfProximity)
		== FALSE) {
		ErrorF("unable to allocate Valuator class device\n");
		return !Success;
	    }
	    else {
		/* allocate the motion history buffer if needed */
		xf86MotionHistoryAllocate(local);
#ifndef XFREE86_V4
		AssignTypeAndName(pGraphireUSB, local->atom, local->name);
#endif
	    }

	    /* open the device to gather informations */
	    xf86GraphireUSBOpenDevice(pGraphireUSB);

	    break;

	case DEVICE_ON:
	    DBG(1, ErrorF("xf86GraphireUSBProc pGraphireUSB=0x%x what=ON\n", pGraphireUSB));

	    if ((local->fd < 0) && (!xf86GraphireUSBOpenDevice(pGraphireUSB))) {
		return !Success;
	    }
#ifdef XFREE86_V4	    
	    xf86AddEnabledDevice(local);
#else
	    AddEnabledDevice(local->fd);
#endif
	    pGraphireUSB->public.on = TRUE;
	    break;

	case DEVICE_OFF:
	    DBG(1, ErrorF("xf86GraphireUSBProc  pGraphireUSB=0x%x what=%s\n", pGraphireUSB,
			  (what == DEVICE_CLOSE) ? "CLOSE" : "OFF"));
	    if (local->fd >= 0) {
#ifdef XFREE86_V4	    
		xf86RemoveEnabledDevice(local);
#else
		RemoveEnabledDevice(local->fd);
#endif
		xf86GraphireUSBClose(local);
	    }
	    pGraphireUSB->public.on = FALSE;
	    break;

	case DEVICE_CLOSE:
	    DBG(1, ErrorF("xf86GraphireUSBProc  pGraphireUSB=0x%x what=%s\n", pGraphireUSB,
			  (what == DEVICE_CLOSE) ? "CLOSE" : "OFF"));
	    xf86GraphireUSBClose(local);
	    break;

	default:
	    ErrorF("unsupported mode=%d\n", what);
	    return !Success;
	    break;
	}
    DBG(2, ErrorF("END   xf86GraphireUSBProc Success what=%d dev=0x%x priv=0x%x\n",
		  what, pGraphireUSB, priv));
    return Success;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBChangeControl -- OK
 *
 ***************************************************************************
 */
static int
xf86GraphireUSBChangeControl(LocalDevicePtr	local,
		     xDeviceCtl		*control)
{
    /* no write-back capabilities on USB event devices. */
    return Success;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBSwitchMode -- OK
 *
 ***************************************************************************
 */
static int
xf86GraphireUSBSwitchMode(ClientPtr	client,
		  DeviceIntPtr	dev,
		  int		mode)
{
    LocalDevicePtr        local = (LocalDevicePtr)dev->public.devicePrivate;
    GraphireUSBDevicePtr        priv = (GraphireUSBDevicePtr)local->private;

    DBG(3, ErrorF("xf86GraphireUSBSwitchMode dev=0x%x mode=%d\n", dev, mode));

    if (mode == Absolute) {
	priv->flags = priv->flags | ABSOLUTE_FLAG;
    }
    else {
	if (mode == Relative) {
	    priv->flags = priv->flags & ~ABSOLUTE_FLAG;
	}
	else {
	    DBG(1, ErrorF("xf86GraphireUSBSwitchMode dev=0x%x invalid mode=%d\n", dev,
			  mode));
	    return BadMatch;
	}
    }
    return Success;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBAllocate -- OK
 *
 ***************************************************************************
 */
static LocalDevicePtr
xf86GraphireUSBAllocate(char *  name,
                int     flag)
{
#ifdef XFREE86_V4
    LocalDevicePtr        local = xf86AllocateInput(graphireusbDrv, 0);
#else
    LocalDevicePtr        local = (LocalDevicePtr) xalloc(sizeof(LocalDeviceRec));
#endif
    GraphireUSBDevicePtr        priv = (GraphireUSBDevicePtr) xalloc(sizeof(GraphireUSBDeviceRec));
    GraphireUSBCommonPtr        common = (GraphireUSBCommonPtr) xalloc(sizeof(GraphireUSBCommonRec));

    local->name = name;
    local->flags = 0;
#ifndef XFREE86_V4
#if !defined(sun) || defined(i386)
    local->device_config = xf86GraphireUSBConfig;
#endif
#endif
    local->device_control = xf86GraphireUSBProc;
    local->read_input = xf86GraphireUSBReadInput;
    local->control_proc = xf86GraphireUSBChangeControl;
    local->close_proc = xf86GraphireUSBClose;
    local->switch_mode = xf86GraphireUSBSwitchMode;
    local->conversion_proc = xf86GraphireUSBConvert;
    local->reverse_conversion_proc = xf86GraphireUSBReverseConvert;
    local->fd = -1;
    local->atom = 0;
    local->dev = NULL;
    local->private = priv;
    local->private_flags = 0;
    local->history_size  = 0;
    local->old_x = -1;
    local->old_y = -1;

    priv->flags = flag;			/* various flags (device type, absolute, first touch...) */
    priv->oldX = -1;			/* previous X position */
    priv->oldY = -1;			/* previous Y position */
    priv->oldZ = -1;			/* previous pressure */
    priv->oldButtons = 0;		/* previous buttons state */
    priv->oldProximity = 0;		/* previous proximity */
    priv->topX = 0;			/* X top */
    priv->topY = 0;			/* Y top */
    priv->bottomX = 0;			/* X bottom */
    priv->bottomY = 0;			/* Y bottom */
    priv->factorX = 0.0;		/* X factor */
    priv->factorY = 0.0;		/* Y factor */
    priv->common = common;		/* common info pointer */
    priv->oldProximity = 0;		/* previous proximity */
    priv->initNumber = 0;	        /* magic number for the init phasis */

    common->graphireUSBDevice = "";		/* device file name */
    common->graphireUSBSuppress = 20;		/* transmit position if increment is superior */
    common->graphireUSBDevices = (LocalDevicePtr*) xalloc(sizeof(LocalDevicePtr));
    common->graphireUSBDevices[0] = local;
    common->graphireUSBCurrentDevice = 0;
    common->graphireUSBCurrentLocal = 0;
    common->graphireUSBNumDevices = 1;		/* number of devices */
    common->graphireUSBMaxX = 0;		/* max X value */
    common->graphireUSBMaxY = 0;		/* max Y value */
    common->graphireUSBMaxZ = 240;		/* max Z value */
    common->graphireUSBResolX = 0;		/* X resolution in points/inch */
    common->graphireUSBResolY = 0;		/* Y resolution in points/inch */
    common->graphireUSBResolZ = 1270;		/* Z resolution in points/inch */
    common->graphireUSBThreshold = INVALID_THRESHOLD; /* button 1 threshold for some tablet models */
    common->graphireUSBInitNumber = 0;	        /* magic number for the init phasis */
    return local;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBAllocateStylus -- OK
 *
 ***************************************************************************
 */
static LocalDevicePtr
xf86GraphireUSBAllocateStylus()
{
    LocalDevicePtr        local = xf86GraphireUSBAllocate(XI_GSTYLUS, STYLUS_ID);

    local->type_name = "Graphire Stylus";
    return local;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBAllocateMouse -- OK
 *
 ***************************************************************************
 */
static LocalDevicePtr
xf86GraphireUSBAllocateMouse()
{
    LocalDevicePtr        local = xf86GraphireUSBAllocate(XI_GMOUSE, MOUSE_ID);

    local->type_name = "Graphire Mouse";
    return local;
}

/*
 ***************************************************************************
 *
 * xf86GraphireUSBAllocateEraser -- OK
 *
 ***************************************************************************
 */
static LocalDevicePtr
xf86GraphireUSBAllocateEraser()
{
    LocalDevicePtr        local = xf86GraphireUSBAllocate(XI_GERASER, ERASER_ID);

    local->type_name = "Graphire Eraser";
    return local;
}

/*
 ***************************************************************************
 *
 * GraphireUSB Stylus device association -- OK
 *
 ***************************************************************************
 */
DeviceAssocRec graphireusb_stylus_assoc =
{
    STYLUS_SECTION_NAME,		/* config_section_name */
    xf86GraphireUSBAllocateStylus		/* device_allocate */
};

/*
 ***************************************************************************
 *
 * GraphireUSB Mouse device association -- OK
 *
 ***************************************************************************
 */
DeviceAssocRec graphireusb_mouse_assoc =
{
    MOUSE_SECTION_NAME,		        /* config_section_name */
    xf86GraphireUSBAllocateMouse		/* device_allocate */
};

/*
 ***************************************************************************
 *
 * GraphireUSB Eraser device association -- OK
 *
 ***************************************************************************
 */
DeviceAssocRec graphireusb_eraser_assoc =
{
    ERASER_SECTION_NAME,		/* config_section_name */
    xf86GraphireUSBAllocateEraser		/* device_allocate */
};

#ifndef XFREE86_V4
#ifdef DYNAMIC_MODULE
/*
 ***************************************************************************
 *
 * entry point of dynamic loading
 *
 ***************************************************************************
 */
int
#ifndef DLSYM_BUG
init_module(unsigned long	server_version)
#else
init_xf86GraphireUSB(unsigned long    server_version)
#endif
{
    xf86AddDeviceAssoc(&graphireusb_stylus_assoc);
    xf86AddDeviceAssoc(&graphireusb_mouse_assoc);
    xf86AddDeviceAssoc(&graphireusb_eraser_assoc);

    if (server_version != XF86_VERSION_CURRENT) {
	ErrorF("Warning: GraphireUSB module compiled for version%s\n", XF86_VERSION);
	return 0;
    } else {
	return 1;
    }
}
#endif /* DYNAMIC_MODULE */

#else /* XFREE86_V4 */

/*
 * xf86GraphireUSBUninit -- OK
 *
 * called when the driver is unloaded.
 */
static void
xf86GraphireUSBUninit(InputDriverPtr	drv,
	      LocalDevicePtr	local,
	      int flags)
{
    GraphireUSBDevicePtr	priv = (GraphireUSBDevicePtr) local->private;

    DBG(1, ErrorF("xf86GraphireUSBUninit\n"));

    xf86GraphireUSBProc(local->dev, DEVICE_OFF);

    xfree (priv);
    xf86DeleteInput(local, 0);
}

/*
 * xf86GraphireUSBInit --
 *
 * called when the module subsection is found in XF86Config
 */
static InputInfoPtr
xf86GraphireUSBInit(InputDriverPtr	drv,
	    IDevPtr		dev,
	    int			flags)
{
    LocalDevicePtr	local = NULL;
    LocalDevicePtr	fakeLocal = NULL;
    GraphireUSBDevicePtr	priv = NULL;
    GraphireUSBCommonPtr	common = NULL;
    char		*s;
    LocalDevicePtr	localDevices;

    graphireusbDrv = drv;

    fakeLocal = (LocalDevicePtr) xcalloc(1, sizeof(LocalDeviceRec));
    fakeLocal->conf_idev = dev;

    /* Force default serial port options to exist because the serial init
     * phasis is based on those values.
     */
    xf86CollectInputOptions(fakeLocal, default_options, NULL);

    /* Type is mandatory */
    s = xf86FindOptionValue(fakeLocal->options, "Type");

    if (s && (xf86NameCmp(s, "gstylus") == 0)) {
	local = xf86GraphireUSBAllocateStylus();
    }
    else if (s && (xf86NameCmp(s, "gmouse") == 0)) {
	local = xf86GraphireUSBAllocateMouse();
    }
    else if (s && (xf86NameCmp(s, "geraser") == 0)) {
	local = xf86GraphireUSBAllocateEraser();
    }
    else {
	xf86Msg(X_ERROR, "%s: No type or invalid type specified.\n"
		"Must be one of gstylus, gmouse or geraser\n",
		dev->identifier);
	goto SetupProc_fail;
    }

    if (local)
	priv = (GraphireUSBDevicePtr) local->private;
    if (priv)
	common = priv->common;

    if (!local || !priv || !common) {
	goto SetupProc_fail;
    }

    local->options = fakeLocal->options;
    local->conf_idev = fakeLocal->conf_idev;
    local->name = dev->identifier;
    xfree(fakeLocal);

    /* Serial Device is mandatory */
    common->graphireUSBDevice = xf86FindOptionValue(local->options, "Device");

    if (!common->graphireUSBDevice) {
	xf86Msg (X_ERROR, "%s: No Device specified.\n", dev->identifier);
	goto SetupProc_fail;
    }

    localDevices = xf86FirstLocalDevice();

    while(localDevices) {
	if ((local != localDevices) &&
	    (localDevices->read_input == xf86GraphireUSBReadInput) &&
	    (strcmp(((GraphireUSBDevicePtr)localDevices->private)->common->graphireUSBDevice,
		    common->graphireUSBDevice) == 0)) {
		DBG(2, ErrorF("xf86GraphireUSBConfig event device share between"
			      " %s and %s\n",
			      local->name, localDevices->name));
		xfree(common->graphireUSBDevices);
		xfree(common);
		common = priv->common = ((GraphireUSBDevicePtr) localDevices->private)->common;
		common->graphireUSBNumDevices++;
		common->graphireUSBDevices = (LocalDevicePtr *) xrealloc(common->graphireUSBDevices,
								 sizeof(LocalDevicePtr) * common->graphireUSBNumDevices);
		common->graphireUSBDevices[common->graphireUSBNumDevices - 1] = local;
		break;
	    }
	localDevices = localDevices->next;
    }

    /* Process the common options. */
    xf86ProcessCommonOptions(local, local->options);

    /* Optional configuration */

    xf86Msg(X_CONFIG, "%s event device is %s\n", dev->identifier,
	    common->graphireUSBDevice);

    debug_level = xf86SetIntOption(local->options, "DebugLevel", 0);
    if (debug_level > 0) {
	xf86Msg(X_CONFIG, "GraphireUSB: debug level set to %d\n", debug_level);
    }

    s = xf86FindOptionValue(local->options, "Mode");

    if (s && (xf86NameCmp(s, "absolute") == 0)) {
	priv->flags = priv->flags | ABSOLUTE_FLAG;
    }
    else if (s && (xf86NameCmp(s, "relative") == 0)) {
	priv->flags = priv->flags & ~ABSOLUTE_FLAG;
    }
    else if (s) {
	xf86Msg(X_ERROR, "%s: invalid Mode (should be absolute or relative). Using default.\n",
		dev->identifier);
    }
    xf86Msg(X_CONFIG, "%s is in %s mode\n", local->name,
	    (priv->flags & ABSOLUTE_FLAG) ? "absolute" : "relative");	

    common->graphireUSBSuppress = xf86SetIntOption(local->options, "Suppress", -1);
    if (common->graphireUSBSuppress != -1) {
	xf86Msg(X_CONFIG, "GraphireUSB: suppress value is %d\n", XCONFIG_GIVEN,
		common->graphireUSBSuppress);
    }

    if (xf86SetBoolOption(local->options, "KeepShape", 0)) {
	priv->flags |= KEEP_SHAPE_FLAG;
	xf86Msg(X_CONFIG, "%s: keeps shape\n", dev->identifier);
    }

    priv->topX = xf86SetIntOption(local->options, "TopX", 0);
    if (priv->topX != 0) {
	xf86Msg(X_CONFIG, "%s: top x = %d\n", dev->identifier, priv->topX);
    }
    priv->topY = xf86SetIntOption(local->options, "TopY", 0);
    if (priv->topY != 0) {
	xf86Msg(X_CONFIG, "%s: top y = %d\n", dev->identifier, priv->topY);
    }
    priv->bottomX = xf86SetIntOption(local->options, "BottomX", 0);
    if (priv->bottomX != 0) {
	xf86Msg(X_CONFIG, "%s: bottom x = %d\n", dev->identifier,
		priv->bottomX);
    }
    priv->bottomY = xf86SetIntOption(local->options, "BottomY", 0);
    if (priv->bottomY != 0) {
	xf86Msg(X_CONFIG, "%s: bottom y = %d\n", dev->identifier,
		priv->bottomY);
    }
    common->graphireUSBThreshold = xf86SetIntOption(local->options, "Threshold", INVALID_THRESHOLD);
    if (common->graphireUSBThreshold != INVALID_THRESHOLD) {
	xf86Msg(X_CONFIG, "%s: threshold = %d\n", dev->identifier,
		common->graphireUSBThreshold);
    }
    common->graphireUSBMaxX = xf86SetIntOption(local->options, "MaxX", 0);
    if (common->graphireUSBMaxX != 0) {
	xf86Msg(X_CONFIG, "%s: max x = %d\n", dev->identifier,
		common->graphireUSBMaxX);
    }
    common->graphireUSBMaxY = xf86SetIntOption(local->options, "MaxY", 0);
    if (common->graphireUSBMaxY != 0) {
	xf86Msg(X_CONFIG, "%s: max y = %d\n", dev->identifier,
		common->graphireUSBMaxY);
    }
    common->graphireUSBMaxZ = xf86SetIntOption(local->options, "MaxZ", 0);
    if (common->graphireUSBMaxZ != 0) {
	xf86Msg(X_CONFIG, "%s: max pressure = %d\n", dev->identifier,
		common->graphireUSBMaxZ);
    }
    common->graphireUSBResolX = xf86SetIntOption(local->options, "ResolutionX", 0);
    if (common->graphireUSBResolX != 0) {
	xf86Msg(X_CONFIG, "%s: resol x = %d\n", dev->identifier,
		common->graphireUSBResolX);
    }
    common->graphireUSBResolY = xf86SetIntOption(local->options, "ResolutionY", 0);
    if (common->graphireUSBResolY != 0) {
	xf86Msg(X_CONFIG, "%s: resol y = %d\n", dev->identifier,
		common->graphireUSBResolY);
    }
    common->graphireUSBResolZ = xf86SetIntOption(local->options, "ResolutionZ", 0);
    if (common->graphireUSBResolZ != 0) {
	xf86Msg(X_CONFIG, "%s: resol pressure = %d\n", dev->identifier,
		common->graphireUSBResolZ);
    }

    /* mark the device configured */
    local->flags |= XI86_POINTER_CAPABLE | XI86_CONFIGURED;

    /* return the LocalDevice */
    return (local);

  SetupProc_fail:
    if (common)
	xfree(common);
    if (priv)
	xfree(priv);
    if (local)
	xfree(local);
    return NULL;
}

#ifdef XFree86LOADER
static
#endif
InputDriverRec GRAPHIREUSB = {
    1,				/* driver version */
    "graphireusb",		/* driver name */
    NULL,			/* identify */
    xf86GraphireUSBInit,		/* pre-init */
    xf86GraphireUSBUninit,		/* un-init */
    NULL,			/* module */
    0				/* ref count */
};

/*
 ***************************************************************************
 *
 * Dynamic loading functions
 *
 ***************************************************************************
 */
#ifdef XFree86LOADER
/*
 * xf86GraphireUSBUnplug -- OK
 *
 * called when the module subsection is found in XF86Config
 */
static void
xf86GraphireUSBUnplug(pointer	p)
{
    DBG(1, ErrorF("xf86GraphireUSBUnplug\n"));
}

/*
 * xf86GraphireUSBPlug -- OK
 *
 * called when the module subsection is found in XF86Config
 */
static pointer
xf86GraphireUSBPlug(pointer	module,
	    pointer	options,
	    int		*errmaj,
	    int		*errmin)
{
    DBG(1, ErrorF("xf86GraphireUSBPlug\n"));
	
    xf86AddInputDriver(&GRAPHIREUSB, module, 0);

    return module;
}

static XF86ModuleVersionInfo xf86GraphireUSBVersionRec =
{
    "graphireusb",
    MODULEVENDORSTRING,
    MODINFOSTRING1,
    MODINFOSTRING2,
    XF86_VERSION_CURRENT,
    1, 0, 0,
    ABI_CLASS_XINPUT,
    ABI_XINPUT_VERSION,
    MOD_CLASS_XINPUT,
    {0, 0, 0, 0}		/* signature, to be patched into the file by */
				/* a tool */
};

XF86ModuleData graphireusbModuleData = {&xf86GraphireUSBVersionRec,
				     xf86GraphireUSBPlug,
				     xf86GraphireUSBUnplug};

#endif /* XFree86LOADER */
#endif /* XFREE86_V4 */

/*
 * Local variables:
 * change-log-default-name: "~/xinput.log"
 * c-file-style: "bsd"
 * End:
 */
/* end of xf86Graphireusb.c */
